diff -r -u squid-2.6.STABLE13/src/comm.c new-STABLE13/src/comm.c
--- squid-2.6.STABLE13/src/comm.c	Tue Apr 17 18:39:56 2007
+++ new-STABLE13/src/comm.c	Sun May 13 00:59:36 2007
@@ -50,18 +50,19 @@
 typedef struct {
     char *host;
     u_short port;
-    struct sockaddr_in S;
+    struct sockaddr_storage S;
     CNCB *callback;
     void *data;
-    struct in_addr in_addr;
+    struct sockaddr_storage in_addr;
     int fd;
     int tries;
+    int ia_cur;
     int addrcount;
     int connstart;
 } ConnectStateData;
 
 /* STATIC */
-static int commBind(int s, struct in_addr, u_short port);
+static int commBind(int s, struct sockaddr *S);
 static void commSetReuseAddr(int);
 static void commSetNoLinger(int);
 static void CommWriteStateCallbackAndFree(int fd, int code);
@@ -111,7 +112,7 @@
 u_short
 comm_local_port(int fd)
 {
-    struct sockaddr_in addr;
+    struct sockaddr_storage addr;
     socklen_t addr_len = 0;
     fde *F = &fd_table[fd];
 
@@ -122,33 +123,29 @@
     }
     if (F->local_port)
 	return F->local_port;
-    addr_len = sizeof(addr);
+    addr_len = sizeof(struct sockaddr_storage);
     if (getsockname(fd, (struct sockaddr *) &addr, &addr_len)) {
 	debug(5, 1) ("comm_local_port: Failed to retrieve TCP/UDP port number for socket: FD %d: %s\n", fd, xstrerror());
 	return 0;
     }
-    F->local_port = ntohs(addr.sin_port);
+    F->local_port = (addr.ss_family == AF_INET6) ?
+		ntohs(((struct sockaddr_in6 *)&addr)->sin6_port):
+		ntohs(((struct sockaddr_in *)&addr)->sin_port) ;
     debug(5, 6) ("comm_local_port: FD %d: port %d\n", fd, (int) F->local_port);
     return F->local_port;
 }
 
 static int
-commBind(int s, struct in_addr in_addr, u_short port)
+commBind(int s, struct sockaddr *S)
 {
-    struct sockaddr_in S;
-
-    memset(&S, '\0', sizeof(S));
-    S.sin_family = AF_INET;
-    S.sin_port = htons(port);
-    S.sin_addr = in_addr;
+    char hbuf[80], sbuf[8];
     statCounter.syscalls.sock.binds++;
-    if (bind(s, (struct sockaddr *) &S, sizeof(S)) == 0)
+    if (bind(s, S, SOCKLEN(S)) == 0)
 	return COMM_OK;
-    debug(5, 0) ("commBind: Cannot bind socket FD %d to %s:%d: %s\n",
-	s,
-	S.sin_addr.s_addr == INADDR_ANY ? "*" : inet_ntoa(S.sin_addr),
-	(int) port,
-	xstrerror());
+    getnameinfo(S, S->sa_family, hbuf, 80, sbuf, 8,
+	NI_NUMERICHOST|NI_NUMERICSERV);
+    debug(5, 0) ("commBind: Cannot bind socket FD %d to %s:%s: %s\n",
+	s, hbuf, sbuf, xstrerror());
     return COMM_ERROR;
 }
 
@@ -157,12 +154,11 @@
 int
 comm_open(int sock_type,
     int proto,
-    struct in_addr addr,
-    u_short port,
+    struct sockaddr *addr,
     int flags,
     const char *note)
 {
-    return comm_openex(sock_type, proto, addr, port, flags, 0, note);
+    return comm_openex(sock_type, proto, addr, flags, 0, note);
 }
 
 
@@ -171,19 +167,19 @@
 int
 comm_openex(int sock_type,
     int proto,
-    struct in_addr addr,
-    u_short port,
+    struct sockaddr *addr,
     int flags,
     unsigned char TOS,
     const char *note)
 {
     int new_socket;
+    u_short port;
     int tos = 0;
     fde *F = NULL;
 
     /* Create socket for accepting new connections. */
     statCounter.syscalls.sock.sockets++;
-    if ((new_socket = socket(AF_INET, sock_type, proto)) < 0) {
+    if ((new_socket = socket(addr->sa_family, sock_type, proto)) < 0) {
 	/* Increase the number of reserved fd's if calls to socket()
 	 * are failing because the open file table is full.  This
 	 * limits the number of simultaneous clients */
@@ -213,12 +209,15 @@
     debug(5, 5) ("comm_open: FD %d is a new socket\n", new_socket);
     fd_open(new_socket, FD_SOCKET, note);
     F = &fd_table[new_socket];
-    F->local_addr = addr;
+    xmemcpy(&F->local_addr, addr, SOCKLEN(addr));
     F->tos = tos;
     if (!(flags & COMM_NOCLOEXEC))
 	commSetCloseOnExec(new_socket);
     if ((flags & COMM_REUSEADDR))
 	commSetReuseAddr(new_socket);
+    port = (addr->sa_family == AF_INET6) ?
+	    ntohs(((struct sockaddr_in6 *)addr)->sin6_port) :
+	    ntohs(((struct sockaddr_in *)addr)->sin_port);
     if (port > (u_short) 0) {
 #ifdef _SQUID_MSWIN_
 	if (sock_type != SOCK_DGRAM)
@@ -227,14 +226,38 @@
 	if (opt_reuseaddr)
 	    commSetReuseAddr(new_socket);
     }
-    if (addr.s_addr != no_addr.s_addr) {
-	if (commBind(new_socket, addr, port) != COMM_OK) {
+    switch (addr->sa_family) {
+    case AF_INET:
+    if (((struct sockaddr_in *)addr)->sin_addr.s_addr != no_addr.s_addr) {
+	if (commBind(new_socket, addr) != COMM_OK) {
+	    comm_close(new_socket);
+	    return -1;
+	}
+    }
+    F->local_port = ntohs(((struct sockaddr_in *)addr)->sin_port);
+    break;
+    case AF_INET6:
+    {
+    struct in6_addr *s6 = &((struct sockaddr_in6 *)addr)->sin6_addr; 
+    if (!IN6_IS_ADDR_ALLF( (struct in6_addr*)&((struct sockaddr_in6 *)addr)->sin6_addr )){
+#ifdef IPV6_V6ONLY
+	const int on = 1;
+	if (setsockopt(new_socket, IPPROTO_IPV6, IPV6_V6ONLY, &on, sizeof(on)) < 0) {
 	    comm_close(new_socket);
 	    return -1;
 	}
+#endif
+	if (commBind(new_socket, addr) != COMM_OK) {
+	    comm_close(new_socket);
+	    return -1;
+	}
+    }
     }
-    F->local_port = port;
+    F->local_port = ntohs(((struct sockaddr_in6 *)addr)->sin6_port);
+    break;
+    }    
 
+    xmemcpy(&F->local_addr, addr, SOCKLEN(addr));
     if (flags & COMM_NONBLOCKING)
 	if (commSetNonBlocking(new_socket) == COMM_ERROR)
 	    return -1;
@@ -268,9 +291,10 @@
 }
 
 void
-commConnectStart(int fd, const char *host, u_short port, CNCB * callback, void *data)
+commConnectStart(int fd, const char *host, u_short port, CNCB *callback, void *data)
 {
     ConnectStateData *cs;
+    FwdState *fwdState = data;
     debug(5, 3) ("commConnectStart: FD %d, %s:%d\n", fd, host, (int) port);
     cs = cbdataAlloc(ConnectStateData);
     cs->fd = fd;
@@ -278,6 +302,7 @@
     cs->port = port;
     cs->callback = callback;
     cs->data = data;
+    cs->ia_cur= fwdState->ia_cur;
     cbdataLock(cs->data);
     comm_add_close_handler(fd, commConnectFree, cs);
     ipcache_nbgethostbyname(host, commConnectDnsHandle, cs);
@@ -298,9 +323,15 @@
 	return;
     }
     assert(ia->cur < ia->count);
-    cs->in_addr = ia->in_addrs[ia->cur];
-    if (Config.onoff.balance_on_multiple_ip)
-	ipcacheCycleAddr(cs->host, NULL);
+    if (Config.onoff.balance_on_multiple_ip) {
+	if (cs->ia_cur < 0) {
+	    ipcacheCycleAddr(cs->host, NULL);
+	    cs->ia_cur = ia->cur;
+	}
+    }
+    else
+	cs->ia_cur = ia->cur;
+    xmemcpy(&cs->in_addr, &ia->in_addrs[cs->ia_cur], sizeof(struct sockaddr_storage));
     cs->addrcount = ia->count;
     cs->connstart = squid_curtime;
     commConnectHandle(cs->fd, cs);
@@ -311,7 +342,9 @@
 {
     CNCB *callback = cs->callback;
     void *data = cs->data;
+    FwdState *fwdState = cs->data;
     int fd = cs->fd;
+    fwdState->ia_cur = cs->ia_cur;
     comm_remove_close_handler(fd, commConnectFree, cs);
     cs->callback = NULL;
     cs->data = NULL;
@@ -339,10 +372,17 @@
 {
     int fd2;
     fde *F;
+    struct sockaddr_storage oldsock;
+    socklen_t oldsocklen = sizeof(oldsock);
     if (!cbdataValid(cs->data))
 	return 0;
     statCounter.syscalls.sock.sockets++;
-    fd2 = socket(AF_INET, SOCK_STREAM, 0);
+    getsockname(cs->fd, (struct sockaddr *)&oldsock, &oldsocklen);
+    F = &fd_table[cs->fd];
+    if (F->local_addr.ss_family == AF_INET6)
+	fd2 = socket(AF_INET6, SOCK_STREAM, 0);
+    else
+	fd2 = socket(AF_INET, SOCK_STREAM, 0);
     statCounter.syscalls.sock.sockets++;
     if (fd2 < 0) {
 	debug(5, 0) ("commResetFD: socket: %s\n", xstrerror());
@@ -365,13 +405,12 @@
 	return 0;
     }
     close(fd2);
-    F = &fd_table[cs->fd];
     fd_table[cs->fd].flags.called_connect = 0;
     /*
      * yuck, this has assumptions about comm_open() arguments for
      * the original socket
      */
-    if (commBind(cs->fd, F->local_addr, F->local_port) != COMM_OK) {
+    if (commBind(cs->fd, &F->local_addr) != COMM_OK) {
 	debug(5, 0) ("commResetFD: bind: %s\n", xstrerror());
 	return 0;
     }
@@ -426,10 +465,14 @@
 commConnectHandle(int fd, void *data)
 {
     ConnectStateData *cs = data;
-    if (cs->S.sin_addr.s_addr == 0) {
-	cs->S.sin_family = AF_INET;
-	cs->S.sin_addr = cs->in_addr;
-	cs->S.sin_port = htons(cs->port);
+    struct sockaddr *sa;
+    if ((cs->in_addr.ss_family == AF_INET) || (cs->in_addr.ss_family == AF_INET6)) {
+	xmemcpy(&cs->S, &cs->in_addr, sizeof(struct sockaddr_storage));
+        sa =(struct sockaddr *)&cs->S;
+        if (sa->sa_family == AF_INET6) 
+	    ((struct sockaddr_in6 *)&cs->S)->sin6_port = htons(cs->port);
+	else
+	    ((struct sockaddr_in *)&cs->S)->sin_port = htons(cs->port);
     }
     switch (comm_connect_addr(fd, &cs->S)) {
     case COMM_INPROGRESS:
@@ -437,14 +480,18 @@
 	commSetSelect(fd, COMM_SELECT_WRITE, commConnectHandle, cs, 0);
 	break;
     case COMM_OK:
-	ipcacheMarkGoodAddr(cs->host, cs->S.sin_addr);
+	ipcacheMarkGoodAddr(cs->host, &cs->S);
 	commConnectCallback(cs, COMM_OK);
 	break;
+    case COMM_ERR_NOSUPPORT:
+    case COMM_ERR_INV_ARGS:
+	commConnectCallback(cs, COMM_ERR_INV_ARGS);
+	break;
     default:
 	cs->tries++;
-	ipcacheMarkBadAddr(cs->host, cs->S.sin_addr);
+	ipcacheMarkBadAddr(cs->host, &cs->S);
 	if (Config.onoff.test_reachability)
-	    netdbDeleteAddrNetwork(cs->S.sin_addr);
+	    netdbDeleteAddrNetwork(&cs->S);
 	if (commRetryConnect(cs)) {
 	    eventAdd("commReconnect", commReconnect, cs, cs->addrcount == 1 ? 0.05 : 0.0, 0);
 	} else {
@@ -477,26 +524,31 @@
 }
 
 int
-comm_connect_addr(int sock, const struct sockaddr_in *address)
+comm_connect_addr(int sock, const struct sockaddr *address)
 {
     int status = COMM_OK;
     fde *F = &fd_table[sock];
     int x;
     int err = 0;
     socklen_t errlen;
-    assert(ntohs(address->sin_port) != 0);
+
+    if (address->sa_family == AF_INET6) 
+	assert(ntohs(((struct sockaddr_in6 *)address)->sin6_port) != 0);
+    else
+	assert(ntohs(((struct sockaddr_in *)address)->sin_port) != 0);
     /* Establish connection. */
     errno = 0;
     if (!F->flags.called_connect) {
 	F->flags.called_connect = 1;
 	statCounter.syscalls.sock.connects++;
-	x = connect(sock, (struct sockaddr *) address, sizeof(*address));
+	x = connect(sock, address, SOCKLEN(address));
 	if (x < 0)
-	    debug(5, 9) ("connect FD %d: %s\n", sock, xstrerror());
+	    debug(5, 2) ("connect FD %d to %s : %s\n", sock, 
+		sockaddr_ntoa(address), xstrerror());
     } else {
 #if defined(_SQUID_NEWSOS6_)
 	/* Makoto MATSUSHITA <matusita@ics.es.osaka-u.ac.jp> */
-	connect(sock, (struct sockaddr *) address, sizeof(*address));
+	connect(sock, address, SOCKLEN(address));
 	if (errno == EINVAL) {
 	    errlen = sizeof(err);
 	    x = getsockopt(sock, SOL_SOCKET, SO_ERROR, &err, &errlen);
@@ -524,10 +576,16 @@
 	status = COMM_OK;
     else if (ignoreErrno(errno))
 	status = COMM_INPROGRESS;
+    else if (errno == COMM_ERR_INV_ARGS)
+	return COMM_ERR_INV_ARGS;
+    else if (errno == COMM_ERR_NOSUPPORT)
+	return COMM_ERR_INV_ARGS;
     else
 	return COMM_ERROR;
-    xstrncpy(F->ipaddr, inet_ntoa(address->sin_addr), 16);
-    F->remote_port = ntohs(address->sin_port);
+    xstrncpy(F->ipaddr, sockaddr_ntoa(address), 80);
+    F->remote_port = (address->sa_family == AF_INET6) ?
+		ntohs(((struct sockaddr_in6 *)address)->sin6_port) :
+		ntohs(((struct sockaddr_in *)address)->sin_port);
     if (status == COMM_OK) {
 	debug(5, 10) ("comm_connect_addr: FD %d connected to %s:%d\n",
 	    sock, F->ipaddr, F->remote_port);
@@ -540,11 +598,11 @@
 /* Wait for an incoming connection on FD.  FD should be a socket returned
  * from comm_listen. */
 int
-comm_accept(int fd, struct sockaddr_in *pn, struct sockaddr_in *me)
+comm_accept(int fd, struct sockaddr *pn, struct sockaddr *me)
 {
     int sock;
-    struct sockaddr_in P;
-    struct sockaddr_in M;
+    struct sockaddr_storage P;
+    struct sockaddr_storage M;
     socklen_t Slen;
     fde *F = NULL;
     Slen = sizeof(P);
@@ -562,19 +620,27 @@
 	}
     }
     if (pn)
-	*pn = P;
+	xmemcpy(pn, &P, SOCKLEN(&P));
     Slen = sizeof(M);
     memset(&M, '\0', Slen);
     getsockname(sock, (struct sockaddr *) &M, &Slen);
     if (me)
-	*me = M;
+	xmemcpy(me, &M, SOCKLEN(&M));
     commSetCloseOnExec(sock);
     /* fdstat update */
     fd_open(sock, FD_SOCKET, "HTTP Request");
     F = &fd_table[sock];
-    xstrncpy(F->ipaddr, inet_ntoa(P.sin_addr), 16);
-    F->remote_port = htons(P.sin_port);
-    F->local_port = htons(M.sin_port);
+    xstrncpy(F->ipaddr, sockaddr_ntoa(&P), 80);
+    switch (P.ss_family) {
+	case AF_INET6:
+	F->remote_port = ntohs(((struct sockaddr_in6 *)&P)->sin6_port);
+	F->local_port = ntohs(((struct sockaddr_in6 *)&M)->sin6_port);
+	break;
+	case AF_INET:
+	F->remote_port = ntohs(((struct sockaddr_in *)&P)->sin_port);
+	F->local_port = ntohs(((struct sockaddr_in *)&M)->sin_port);
+	break;
+    }
     commSetNonBlocking(sock);
     return sock;
 }
@@ -762,22 +828,25 @@
 /* Send a udp datagram to specified TO_ADDR. */
 int
 comm_udp_sendto(int fd,
-    const struct sockaddr_in *to_addr,
+    const struct sockaddr *to_addr,
     int addr_len,
     const void *buf,
     int len)
 {
     int x;
+    char hbuf[100], sbuf[8];
     statCounter.syscalls.sock.sendtos++;
-    x = sendto(fd, buf, len, 0, (struct sockaddr *) to_addr, addr_len);
+    x = sendto(fd, buf, len, 0, to_addr, SOCKLEN(to_addr));
     if (x < 0) {
+	getnameinfo(to_addr, SOCKLEN(to_addr), hbuf, 100, sbuf, 8,
+		NI_NUMERICHOST|NI_NUMERICSERV);
 #ifdef _SQUID_LINUX_
 	if (ECONNREFUSED != errno)
 #endif
-	    debug(5, 1) ("comm_udp_sendto: FD %d, %s, port %d: %s\n",
+	    debug(5, 1) ("comm_udp_sendto: FD %d, %s, port %s: %s\n",
 		fd,
-		inet_ntoa(to_addr->sin_addr),
-		(int) htons(to_addr->sin_port),
+		hbuf,
+		sbuf,
 		xstrerror());
 	return COMM_ERROR;
     }
diff -r -u squid-2.6.STABLE13/src/comm_generic.c new-STABLE13/src/comm_generic.c
--- squid-2.6.STABLE13/src/comm_generic.c	Wed Nov  1 03:25:15 2006
+++ new-STABLE13/src/comm_generic.c	Sun May 13 00:59:36 2007
@@ -165,6 +165,10 @@
 	do_call_incoming(theInIcpConnection);
     if (theOutIcpConnection != theInIcpConnection)
 	do_call_incoming(theOutIcpConnection);
+    if (theInIcpConnection6 >= 0)
+	do_call_incoming(theInIcpConnection6);
+    if (theOutIcpConnection6 != theInIcpConnection6)
+	do_call_incoming(theOutIcpConnection6);
 }
 
 static inline void
diff -r -u squid-2.6.STABLE13/src/defines.h new-STABLE13/src/defines.h
--- squid-2.6.STABLE13/src/defines.h	Sun Feb  4 07:58:20 2007
+++ new-STABLE13/src/defines.h	Sun May 13 00:59:36 2007
@@ -84,6 +84,8 @@
 #define COMM_ERR_CONNECT (-7)
 #define COMM_ERR_DNS     (-8)
 #define COMM_ERR_CLOSING (-9)
+#define COMM_ERR_INV_ARGS (22)
+#define COMM_ERR_NOSUPPORT (97)
 
 /* Select types. */
 #define COMM_SELECT_READ   (0x1)
@@ -364,4 +366,18 @@
 #define	DLINK_ISEMPTY(n)	( (n).head == NULL )
 #define	DLINK_HEAD(n)		( (n).head->data )
 
+/*
+ * Macro to compare IPv6 addresses (b is 0, 4, 8, 12)
+ */
+#define IN6_NTOHL_N(a,b)        \
+        (ntohl(*(const u_int32_t *)(const void *)(&(a)->s6_addr[(b)])))
+
+#define IN6_IS_ADDR_ALLF(a)	\
+	(IN6_NTOHL_N(a,0) & IN6_NTOHL_N(a,4) & 			\
+		IN6_NTOHL_N(a,8) & IN6_NTOHL_N(a,12) == 	\
+		(u_int32_t)0xffffffff)
+
+#define SOCKLEN(a)	\
+	(((struct sockaddr_storage *)(a))->ss_family == AF_INET6 ?	\
+	    sizeof(struct sockaddr_in6) : sizeof(struct sockaddr_in))
 #endif /* SQUID_DEFINES_H */
diff -r -u squid-2.6.STABLE13/src/delay_pools.c new-STABLE13/src/delay_pools.c
--- squid-2.6.STABLE13/src/delay_pools.c	Mon Oct 23 20:22:21 2006
+++ new-STABLE13/src/delay_pools.c	Sun May 13 00:59:36 2007
@@ -322,12 +322,13 @@
 	ch.src_addr = r->indirect_client_addr;
     } else
 #endif /* FOLLOW_X_FORWARDED_FOR */
-	ch.src_addr = r->client_addr;
-    ch.my_addr = r->my_addr;
+    xmemcpy(&ch.src_addr, &r->client_addr, SOCKLEN(&r->client_addr));
+    xmemcpy(&ch.my_addr, &r->my_addr, SOCKLEN(&r->my_addr));
     ch.my_port = r->my_port;
     ch.conn = http->conn;
     ch.request = r;
-    if (r->client_addr.s_addr == INADDR_BROADCAST) {
+    if (r->client_addr.ss_family == AF_INET && 
+	((struct sockaddr_in *)&r->client_addr)->sin_addr.s_addr == INADDR_BROADCAST) {
 	debug(77, 2) ("delayClient: WARNING: Called with 'allones' address, ignoring\n");
 	return delayId(0, 0);
     }
@@ -343,7 +344,10 @@
     if (class == 1)
 	return delayId(pool + 1, 0);
     if (class == 2) {
+/* XXX husni
 	host = ntohl(ch.src_addr.s_addr) & 0xff;
+*/
+	host = 255;
 	if (host == 255) {
 	    if (!delay_data[pool].class2->individual_255_used) {
 		delay_data[pool].class2->individual_255_used = 1;
@@ -369,7 +373,10 @@
 	return delayId(pool + 1, i);
     }
     /* class == 3 */
+/* XXX husni
     host = ntohl(ch.src_addr.s_addr) & 0xffff;
+*/
+    host = 0xffff;
     net = host >> 8;
     host &= 0xff;
     if (net == 255) {
diff -r -u squid-2.6.STABLE13/src/dns_internal.c new-STABLE13/src/dns_internal.c
--- squid-2.6.STABLE13/src/dns_internal.c	Sun Dec 17 19:51:44 2006
+++ new-STABLE13/src/dns_internal.c	Sun May 13 00:59:36 2007
@@ -89,12 +89,14 @@
 
 struct _idns_query {
     hash_link hash;
+    int ia_cur;
     rfc1035_query query;
+    char query_key[RFC1035_MAXHOSTNAMESZ+5];
     char buf[RESOLV_BUFSZ];
     char name[NS_MAXDNAME + 1];
     char orig[NS_MAXDNAME + 1];
     ssize_t sz;
-    unsigned short id;
+    unsigned short id, id_pair;
     int nsends;
     struct timeval start_t;
     struct timeval sent_t;
@@ -114,7 +116,7 @@
 };
 
 struct _ns {
-    struct sockaddr_in S;
+    struct sockaddr_storage S;
     int nqueries;
     int nreplies;
 };
@@ -150,7 +152,7 @@
 #endif
 static void idnsCacheQuery(idns_query * q);
 static void idnsSendQuery(idns_query * q);
-static int idnsFromKnownNameserver(struct sockaddr_in *from);
+static int idnsFromKnownNameserver(struct sockaddr *from);
 static idns_query *idnsFindQuery(unsigned short id);
 static void idnsGrokReply(const char *buf, size_t sz);
 static PF idnsRead;
@@ -161,12 +163,13 @@
 static void
 idnsAddNameserver(const char *buf)
 {
-    struct in_addr A;
+    struct sockaddr_storage A;
     if (!safe_inet_addr(buf, &A)) {
 	debug(78, 0) ("WARNING: rejecting '%s' as a name server, because it is not a numeric IP address\n", buf);
 	return;
     }
-    if (A.s_addr == 0) {
+    if ( ((A.ss_family == AF_INET6) && IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&A)->sin6_addr)) ||
+    	((A.ss_family == AF_INET) && (((struct sockaddr_in *)&A)->sin_addr.s_addr == 0)) ) {
 	debug(78, 0) ("WARNING: Squid does not accept 0.0.0.0 in DNS server specifications.\n");
 	debug(78, 0) ("Will be using 127.0.0.1 instead, assuming you meant that DNS is running on the same machine\n");
 	safe_inet_addr("127.0.0.1", &A);
@@ -185,11 +188,13 @@
 	    safe_free(oldptr);
     }
     assert(nns < nns_alloc);
-    nameservers[nns].S.sin_family = AF_INET;
-    nameservers[nns].S.sin_port = htons(NS_DEFAULTPORT);
-    nameservers[nns].S.sin_addr.s_addr = A.s_addr;
+    xmemcpy(&nameservers[nns].S, &A, sizeof(struct sockaddr_storage));
+    if (A.ss_family == AF_INET)
+	((struct sockaddr_in *)&nameservers[nns].S)->sin_port =  htons(NS_DEFAULTPORT);
+    if (A.ss_family == AF_INET6)
+	((struct sockaddr_in6 *)&nameservers[nns].S)->sin6_port =  htons(NS_DEFAULTPORT);
     debug(78, 3) ("idnsAddNameserver: Added nameserver #%d: %s\n",
-	nns, inet_ntoa(nameservers[nns].S.sin_addr));
+	nns, sockaddr_ntoa(&nameservers[nns].S));
     nns++;
 }
 
@@ -499,7 +504,7 @@
     storeAppendPrintf(sentry, "--------------- --------- ---------\n");
     for (i = 0; i < nns; i++) {
 	storeAppendPrintf(sentry, "%-15s %9d %9d\n",
-	    inet_ntoa(nameservers[i].S.sin_addr),
+	    sockaddr_ntoa(&nameservers[i].S),
 	    nameservers[i].nqueries,
 	    nameservers[i].nreplies);
     }
@@ -551,6 +556,7 @@
 {
     int x;
     int ns;
+    int DnsSocketTemp;
     if (DnsSocket < 0) {
 	debug(78, 1) ("idnsSendQuery: Can't send query, no DNS socket!\n");
 	return;
@@ -562,21 +568,29 @@
     idnsTcpCleanup(q);
   try_again:
     ns = q->nsends % nns;
-    x = comm_udp_sendto(DnsSocket,
+    if (nameservers[ns].S.ss_family == AF_INET6)
+	DnsSocketTemp = DnsSocket6;
+    else
+	DnsSocketTemp = DnsSocket;
+	
+    x = comm_udp_sendto(DnsSocketTemp,
 	&nameservers[ns].S,
-	sizeof(nameservers[ns].S),
+	SOCKLEN(&nameservers[ns].S),
 	q->buf,
 	q->sz);
     q->nsends++;
     q->sent_t = current_time;
     if (x < 0) {
 	debug(50, 1) ("idnsSendQuery: FD %d: sendto: %s\n",
-	    DnsSocket, xstrerror());
+	    DnsSocketTemp, xstrerror());
 	if (q->nsends % nns != 0)
 	    goto try_again;
     } else {
-	fd_bytes(DnsSocket, x, FD_WRITE);
-	commSetSelect(DnsSocket, COMM_SELECT_READ, idnsRead, NULL, 0);
+	fd_bytes(DnsSocketTemp, x, FD_WRITE);
+/*
+	if (q->query.qtype == RFC1035_TYPE_A)
+*/
+	commSetSelect(DnsSocketTemp, COMM_SELECT_READ, idnsRead, NULL, 0);
     }
     nameservers[ns].nqueries++;
     dlinkAdd(q, &q->lru, &lru_list);
@@ -584,13 +598,19 @@
 }
 
 static int
-idnsFromKnownNameserver(struct sockaddr_in *from)
+idnsFromKnownNameserver(struct sockaddr *from)
 {
     int i;
     for (i = 0; i < nns; i++) {
-	if (nameservers[i].S.sin_addr.s_addr != from->sin_addr.s_addr)
+	if (nameservers[i].S.ss_family != from->sa_family)
+	    continue;
+	if (from->sa_family == AF_INET &&
+	    (((struct sockaddr_in *)&nameservers[i].S)->sin_addr.s_addr != ((struct sockaddr_in *)from)->sin_addr.s_addr ||
+	    ((struct sockaddr_in *)&nameservers[i].S)->sin_port != ((struct sockaddr_in *)from)->sin_port))
 	    continue;
-	if (nameservers[i].S.sin_port != from->sin_port)
+	if (from->sa_family == AF_INET6 &&
+	    (!IN6_ARE_ADDR_EQUAL( &((struct sockaddr_in6 *)&nameservers[i].S)->sin6_addr, &((struct sockaddr_in6 *)from)->sin6_addr) ||
+	    ((struct sockaddr_in6 *)&nameservers[i].S)->sin6_port != ((struct sockaddr_in6 *)from)->sin6_port))
 	    continue;
 	return i;
     }
@@ -724,23 +744,34 @@
 static void
 idnsRetryTcp(idns_query * q)
 {
-    struct in_addr addr;
+    struct sockaddr_storage addr;
+    char host[100], port[8];
     int ns = (q->nsends - 1) % nns;
     idnsTcpCleanup(q);
-    if (Config.Addrs.udp_outgoing.s_addr != no_addr.s_addr)
-	addr = Config.Addrs.udp_outgoing;
-    else
-	addr = Config.Addrs.udp_incoming;
+    if (nameservers[ns].S.ss_family == AF_INET6) {
+	if (!IN6_IS_ADDR_ALLF(&((struct sockaddr_in6 *)&Config.Addrs.udp6_outgoing)->sin6_addr)) 
+	    xmemcpy(&addr, &Config.Addrs.udp6_outgoing, sizeof(addr));
+	else
+	    xmemcpy(&addr, &Config.Addrs.udp6_incoming, sizeof(addr));
+    }
+    else {
+	if (((struct sockaddr_in *)&Config.Addrs.udp_outgoing)->sin_addr.s_addr != no_addr.s_addr)
+	    xmemcpy(&addr, &Config.Addrs.udp_outgoing, sizeof(addr));
+	else
+	    xmemcpy(&addr, &Config.Addrs.udp_incoming, sizeof(addr));
+    }
     q->tcp_socket = comm_open(SOCK_STREAM,
 	IPPROTO_TCP,
-	addr,
-	0,
+	&addr,
 	COMM_NONBLOCKING,
 	"DNS TCP Socket");
     dlinkAdd(q, &q->lru, &lru_list);
+    q->ia_cur = -1;
     commConnectStart(q->tcp_socket,
-	inet_ntoa(nameservers[ns].S.sin_addr),
-	ntohs(nameservers[ns].S.sin_port),
+	sockaddr_ntoa(&nameservers[ns].S),
+	nameservers[ns].S.ss_family == AF_INET6 ?
+	    ntohs(((struct sockaddr_in6 *)&nameservers[ns])->sin6_port) :
+	    ntohs(((struct sockaddr_in *)&nameservers[ns])->sin_port) ,
 	idnsSendTcpQuery,
 	q
 	);
@@ -751,7 +782,7 @@
 {
     int n;
     rfc1035_message *message = NULL;
-    idns_query *q;
+    idns_query *q, *q_pair;
     n = rfc1035MessageUnpack(buf,
 	sz,
 	&message);
@@ -768,6 +799,9 @@
 	rfc1035MessageDestroy(message);
 	return;
     }
+
+    q_pair = idnsFindQuery(q->id_pair);
+
     if (rfc1035QueryCompare(&q->query, message->query) != 0) {
 	debug(78, 3) ("idnsGrokReply: Query mismatch (%s != %s)\n", q->query.name, message->query->name);
 	rfc1035MessageDestroy(message);
@@ -823,6 +857,9 @@
 	    return;
 	}
     }
+    if (q_pair)
+	n = n + 10000;
+    debug(78, 3) ("idnsGrokReply: id %d pair %d: %d\n", q->id, q_pair ? q->id_pair: -1, n);
     idnsCallback(q, message->answer, n, q->error);
     rfc1035MessageDestroy(message);
 
@@ -835,7 +872,7 @@
 {
     int *N = &incoming_sockets_accepted;
     ssize_t len;
-    struct sockaddr_in from;
+    struct sockaddr_storage from;
     socklen_t from_len;
     int max = INCOMING_DNS_MAX;
     static char rbuf[SQUID_UDP_SO_RCVBUF];
@@ -861,13 +898,13 @@
 		    fd, xstrerror());
 	    break;
 	}
-	fd_bytes(DnsSocket, len, FD_READ);
+	fd_bytes(fd, len, FD_READ);
 	assert(N);
 	(*N)++;
 	debug(78, 3) ("idnsRead: FD %d: received %d bytes from %s.\n",
 	    fd,
 	    (int) len,
-	    inet_ntoa(from.sin_addr));
+	    sockaddr_ntoa(&from));
 	ns = idnsFromKnownNameserver(&from);
 	if (ns >= 0) {
 	    nameservers[ns].nreplies++;
@@ -875,7 +912,7 @@
 	    static time_t last_warning = 0;
 	    if (squid_curtime - last_warning > 60) {
 		debug(78, 1) ("WARNING: Reply from unknown nameserver [%s]\n",
-		    inet_ntoa(from.sin_addr));
+		    sockaddr_ntoa(&from));
 		last_warning = squid_curtime;
 	    }
 	    continue;
@@ -883,7 +920,7 @@
 	idnsGrokReply(rbuf, len);
     }
     if (lru_list.head)
-	commSetSelect(DnsSocket, COMM_SELECT_READ, idnsRead, NULL, 0);
+	commSetSelect(fd, COMM_SELECT_READ, idnsRead, NULL, 0);
 }
 
 static void
@@ -945,15 +982,15 @@
     CBDATA_INIT_TYPE(idns_query);
     if (DnsSocket < 0) {
 	int port;
-	struct in_addr addr;
-	if (Config.Addrs.udp_outgoing.s_addr != no_addr.s_addr)
-	    addr = Config.Addrs.udp_outgoing;
-	else
-	    addr = Config.Addrs.udp_incoming;
+	struct sockaddr_storage addr;
+	memset(&addr, 0, sizeof(addr));
+	addr.ss_family = AF_INET;
+#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
+	addr.ss_len = sizeof(struct sockaddr_in);
+#endif
 	DnsSocket = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    addr,
-	    0,
+	    &addr,
 	    COMM_NONBLOCKING,
 	    "DNS Socket");
 	if (DnsSocket < 0)
@@ -963,9 +1000,32 @@
 	 */
 	port = comm_local_port(DnsSocket);
 	debug(78, 1) ("DNS Socket created at %s, port %d, FD %d\n",
-	    inet_ntoa(addr),
+	    sockaddr_ntoa(&addr),
 	    port, DnsSocket);
     }
+    if (DnsSocket6 < 0) {
+	int port;
+	struct sockaddr_storage addr;
+	memset(&addr, 0, sizeof(addr));
+	addr.ss_family = AF_INET6;
+#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
+	addr.ss_len = sizeof(struct sockaddr_in6);
+#endif
+	DnsSocket6 = comm_open(SOCK_DGRAM,
+	    IPPROTO_UDP,
+	    &addr,
+	    COMM_NONBLOCKING,
+	    "DNS Socket v6");
+	if (DnsSocket < 0)
+	    fatal("Could not create a DNS socket");
+	/* Ouch... we can't call functions using debug from a debug
+	 * statement. Doing so messes up the internal _db_level
+	 */
+	port = comm_local_port(DnsSocket6);
+	debug(78, 1) ("DNS Socket v6 created at %s, port %d, FD %d\n",
+	    sockaddr_ntoa(&addr),
+	    port, DnsSocket6);
+    }
     assert(0 == nns);
     idnsParseNameservers();
 #ifndef _SQUID_MSWIN_
@@ -1000,10 +1060,12 @@
 void
 idnsShutdown(void)
 {
-    if (DnsSocket < 0)
+    if (DnsSocket < 0 && DnsSocket6 < 0)
 	return;
     comm_close(DnsSocket);
+    comm_close(DnsSocket6);
     DnsSocket = -1;
+    DnsSocket6 = -1;
     idnsFreeNameservers();
     idnsFreeSearchpath();
 }
@@ -1028,21 +1090,84 @@
 static void
 idnsCacheQuery(idns_query * q)
 {
-    q->hash.key = q->query.name;
+    q->hash.key = q->query_key;
     hash_join(idns_lookup_hash, &q->hash);
 }
 
+static void
+idnsAAAALookup(const char *name, IDNSCB * callback, void *data, unsigned short id_pair, unsigned short id)
+{
+    unsigned int i;
+    int nd = 0;
+    idns_query *q;
+    char query_key[RFC1035_MAXHOSTNAMESZ+5];
+    snprintf(query_key, RFC1035_MAXHOSTNAMESZ+5, "%s%d", name, RFC1035_TYPE_AAAA);
+    if (idnsCachedLookup(query_key, callback, data))
+	return;
+    if (!id_pair && !id)
+	return;
+    q = cbdataAlloc(idns_query);
+    q->tcp_socket = -1;
+    q->id = id;
+    q->id_pair = id_pair;
+
+    for (i = 0; i < strlen(name); i++) {
+	if (name[i] == '.') {
+	    nd++;
+	}
+    }
+
+    if (Config.onoff.res_defnames && npc > 0 && name[strlen(name) - 1] != '.') {
+	q->do_searchpath = 1;
+    } else {
+	q->do_searchpath = 0;
+    }
+    strcpy(q->orig, name);
+    strcpy(q->name, q->orig);
+    if (q->do_searchpath && nd < ndots) {
+	q->domain = 0;
+	strcat(q->name, ".");
+	strcat(q->name, searchpath[q->domain].domain);
+	debug(78, 3) ("idnsALookup: searchpath used for %s\n",
+	    q->name);
+    }
+    q->sz = rfc1035BuildAAAAQuery(q->name, q->buf, sizeof(q->buf), q->id,
+	&q->query);
+
+    if (q->sz < 0) {
+	/* problem with query data -- query not sent */
+	callback(data, NULL, 0, "Internal error");
+	cbdataFree(q);
+	return;
+    }
+    debug(78, 3) ("idnsAAAALookup: buf is %d bytes for %s, id = %#hx\n",
+	(int) q->sz, q->name, q->id);
+    snprintf(q->query_key, RFC1035_MAXHOSTNAMESZ+5, "%s%d", q->query.name, q->query.qtype);
+    q->callback = callback;
+    q->callback_data = data;
+    cbdataLock(q->callback_data);
+    q->start_t = current_time;
+    idnsCacheQuery(q);
+    idnsSendQuery(q);
+}
+
+
 void
 idnsALookup(const char *name, IDNSCB * callback, void *data)
 {
     unsigned int i;
     int nd = 0;
     idns_query *q;
-    if (idnsCachedLookup(name, callback, data))
+    char query_key[RFC1035_MAXHOSTNAMESZ+5];
+    snprintf(query_key, RFC1035_MAXHOSTNAMESZ+5, "%s%d", name, RFC1035_TYPE_A);
+    if (idnsCachedLookup(query_key, callback, data)) {
+	idnsAAAALookup(name, callback, data, 0, 0);
 	return;
+    }
     q = cbdataAlloc(idns_query);
     q->tcp_socket = -1;
     q->id = idnsQueryID();
+    q->id_pair = idnsQueryID();
 
     for (i = 0; i < strlen(name); i++) {
 	if (name[i] == '.') {
@@ -1075,19 +1200,21 @@
     }
     debug(78, 3) ("idnsALookup: buf is %d bytes for %s, id = %#hx\n",
 	(int) q->sz, q->name, q->id);
+    snprintf(q->query_key, RFC1035_MAXHOSTNAMESZ+5, "%s%d", q->query.name, q->query.qtype);
     q->callback = callback;
     q->callback_data = data;
     cbdataLock(q->callback_data);
     q->start_t = current_time;
     idnsCacheQuery(q);
     idnsSendQuery(q);
+    idnsAAAALookup(name, callback, data, q->id, q->id_pair);
 }
 
 void
-idnsPTRLookup(const struct in_addr addr, IDNSCB * callback, void *data)
+idnsPTRLookup(const struct sockaddr *addr, IDNSCB * callback, void *data)
 {
     idns_query *q;
-    const char *ip = inet_ntoa(addr);
+    const char *ip = sockaddr_ntoa(addr);
     q = cbdataAlloc(idns_query);
     q->tcp_socket = -1;
     q->id = idnsQueryID();
diff -r -u squid-2.6.STABLE13/src/errorpage.c new-STABLE13/src/errorpage.c
--- squid-2.6.STABLE13/src/errorpage.c	Fri Jan 19 09:21:01 2007
+++ new-STABLE13/src/errorpage.c	Sun May 13 00:59:36 2007
@@ -507,7 +507,7 @@
 	    p = "[unknown host]";
 	break;
     case 'i':
-	memBufPrintf(&mb, "%s", inet_ntoa(err->src_addr));
+	memBufPrintf(&mb, "%s", sockaddr_ntoa(&err->src_addr));
 	break;
     case 'I':
 	if (r && r->hier.host) {
diff -r -u squid-2.6.STABLE13/src/external_acl.c new-STABLE13/src/external_acl.c
--- squid-2.6.STABLE13/src/external_acl.c	Tue Jan  2 08:32:13 2007
+++ new-STABLE13/src/external_acl.c	Sun May 13 00:59:37 2007
@@ -639,14 +639,14 @@
 	    break;
 #endif
 	case EXT_ACL_SRC:
-	    str = inet_ntoa(ch->src_addr);
+	    str = sockaddr_ntoa(&ch->src_addr);
 	    break;
 	case EXT_ACL_SRCPORT:
 	    snprintf(buf, sizeof(buf), "%d", request->client_port);
 	    str = buf;
 	    break;
 	case EXT_ACL_MYADDR:
-	    str = inet_ntoa(request->my_addr);
+	    str = sockaddr_ntoa(&request->my_addr);
 	    break;
 	case EXT_ACL_MYPORT:
 	    snprintf(buf, sizeof(buf), "%d", request->my_port);
